/*	dmc.h
 *
 * various dmc definitions
 */

/* number of items in a DMC entry, input, output formats for C */

#define DMC_entry_count	8 
#define DMC_entry_reclen 135	/* including tabs and lf at end */

#define DMC_entry_scan_format \
"%5c%*c%2c%*c%3c%*c%2c%*c%%22c%*c%22c%*c%30c%*c%30c%*c%2c"

#define DMC_request_count (DMC_entry_count + 2)
#define DMC_request_reclen (DMC_entry_reclen + 46)

#define DMC_request_scan_format \
"%5c%*c%2c%*c%3c%*c%2c%*%22c%*c%22c%*c30c%*c%30c%*c%2c%*c%22c%*c%22c"

/* dmc holdings file entry, as it exists in memory */
struct DMC_entry 
{
	char statn[6];		/* standard station call letters */
	char network[3];	/* network id */
	char chn[4];		/* channel identifier */
	char location[3];	/* location id */
	char start[23];		/* start time per seed resolution */
	char end[23];		/* end time ditto */
	char file[31];		/* file name */
	char superfile[31];	/* name of container file "file" is in */
				/* first 6 chars is name of directory to
				   find headers in (21-aug-89) */
} ;

struct DMC_request {
	struct DMC_entry entry;
	char reqstart[23];	/* request start time */
	char reqend[23];	/* request end time */
	} ;

