/*===========================================================================*/
/* DMC interim out |               get_creator             |         utility */
/*===========================================================================*/
/*
	Name:		get_creator
	Purpose:	recover CREATOR value from environment
	Usage:		get_creator();
	Input:		none
	Output:		result = string equivalent of environment creator
	Externals:	SEED_Version - if not 2.2, no warning given
	Messages:	none
	Warnings:	none
	Errors:		none
	Fatals:		none
	Called by:	anything
	Calls to:	none
	Algorithm:
	Notes:		usually called from main routine
	Problems:	none known
	Debug:		not used
	References:	none
	Language:	C
	Revisions:	written 03dec91, mark wiederspahn
*/

#include "output.h"

char *get_creator()
{
	char *charptr;							/* ptr to value of CREATOR */
	char *result;

	if ((charptr = (char *) getenv ("CREATOR")) == NULL)
	{
		if( SEED_Version >= 22 ) error_handler( WARNING,
			"get_creator: CREATOR not specified in environment" );
		result =  "UNSPECIFIED";
	}
	else
	{
		if( strlen( charptr ) > 60 )
		{
			error_handler( WARNING,
				"get_creator: CREATOR string truncated to 60 chars" );
			*(charptr+60) = '\0';
		}
		result = charptr;
	}
		
	if( Debug )
		fprintf( D_OUT,"[get_creator] Organization is: %s\n", result );
	return( result );
}
