/*===========================================================================*/
/* DMC Interim     |           build_abbrev_path           |    Header_phase */
/*===========================================================================*/
/*
	Name:		build_abbrev_path
	Purpose:	construct the base path to station info
	Usage:		int build_abbrev_path ();
				char *basepath;
				char *path;
				int error;
				error = build_abbrev_path (basepath, path);
	Input:		basepath = string containing path to directory containing
					abbreviation info
	Output:		path = string containing path to abbreviation info
				error = error value; FALSE if no error, nonzero otherwise. It
					contains values of MESSAGE, WARNING, ERROR, or FATAL
					(see constants.h)
	Externals:	Debug - setting of environment variable DEBUG (globals.h)
	Messages:	none
	Warnings:	none
	Errors:		none
	Fatals:		none
	Called by:	get_abbrev_hdr
	Calls to:	
	Algorithm:	
	Notes:		none
	Problems:	none known
	Debug:		level D_MIN - print out start and finish notices
				level D_MED - print out constructed path
				level D_MAX - not used
	References:	none
	Language:	C, more or less ANSI standard, under Sun OS 3.5
	Revisions:	02/24/89  Dennis O'Neill  original version
				05/04/89  Kevin MacKenzie  removed unused error argument
*/

#include "output.h"

#ifndef CTYPE_INCLUDED
#include <ctype.h>
#define CTYPE_INCLUDED 1
#endif

int build_abbrev_path (basepath, path)
char *basepath;									/* root path to abbrev info */
char *path;										/* path to abbreviation info */
{
	int error;									/* returned error status */
	unsigned int namelength;					/* length of stn name */
	char message[MSGLENGTH+1];					/* error message string */
	int i;										/* general use int */

	if (Debug >= D_MIN)
		fprintf (D_OUT, "[build_abbrev_path] Started.\n");
	error = FALSE;

                   /*=====================================*/
/*=================|           build path name             |=================*/
                   /*=====================================*/

	sprintf (path, "%s", basepath);

	if (Debug >= D_MED)
		fprintf (D_OUT, "[build_abbrev_path] Path is %s.\n", path);

	if (Debug >= D_MIN)
		fprintf (D_OUT, "[build_abbrev_path] Completed.\n");

	return (error);
}
