/*===========================================================================*/
/*                 |              macros.h                 |     header file */
/*===========================================================================*/
/*
	Name:		macros.h
	Purpose:	header file containing commonly-used macro definitions
	Usage:		#include "macros.h"
	Input:		not applicable
	Output:		not applicable
	Externals:	not applicable
	Warnings:	not applicable
	Errors:		not applicable
	Called by:	anything
	Calls to:	none
	Algorithm:	various; see the macros
	Notes:		none
	Problems:	none known
	References:	none
	Language:	C
	Author:		Dennis O'Neill
	Revisions:	07/15/88  Dennis O'Neill  Initial preliminary release 0.9
				11/21/88  Dennis O'Neill  Production release 1.0
*/

/* if this header is already included, don't include it again */
#ifndef MACROS_INCLUDED

                  /*=======================================*/
/*================|             Macro definitions           |================*/
                  /*=======================================*/

/* Type-independant absolute value for C standard types */
#ifndef abs
#define abs(x) ((x)<0?-(x):(x))
#endif

/* Type-independant maximum value for C standard types */
#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#endif

/* Type-independant minimum value for C standard types */
#ifndef min
#define min(x,y) ((x)<(y)?(x):(y))
#endif

                  /*=======================================*/
/*================|         End of the header file          |================*/
                  /*=======================================*/

/* the following two lines should be the last lines of the header file */
#define MACROS_INCLUDED 1
#endif
