/*===========================================================================*/
/* DMC interim out |      asc_to_input_time.c              | Utility         */
/*===========================================================================*/
/*
	Name:		asc_to_input_time( string )
	Purpose:	decodes a SEED time string
	Usage:		
	Input:		char	*string
				of the form: 1988,365,23:59:59.9999
				Trailing units may be droppped, and
				are assumed to be zero.
	Output:		
	Externals:	
	Warnings:	
	Errors:		
	Fatals:
	Called by:	
	Calls to:	
	Algorithm:	
	Notes:		
	Problems:	
	References:	
	Language:	
	Revisions:	03/10/89	mark wiederspahn	written
*/

#include "output.h"

struct input_time asc_to_input_time( string )
char	*string;
{
struct	input_time	time;
int		i,j,k;

/*
 * scanf has trouble with bytes, so use ints for them
 */
	time.year=time.day=time.hour=time.minute=time.second=time.fracsec = 0;
	i = j = k = 0;
	sscanf( string, "%4hd,%3hd,%2d:%2d:%2d.%4hd", &time.year, &time.day,
			&i, &j, &k, &time.fracsec );
	time.hour = i;
	time.minute = j;
	time.second = k;
	return( time );
}
