/*===========================================================================*/
/* DMC interim out |            get_debug_level            |         utility */
/*===========================================================================*/
/*
	Name:		get_debug_level
	Purpose:	recover DEBUG value from environment
	Usage:		int get_debug_level ();
				int result;
				result = get_debug_level ();
	Input:		none
	Output:		result = numeric equivalent of environment variable DEBUG
	Externals:	none
	Messages:	none
	Warnings:	none
	Errors:		none
	Fatals:		none
	Called by:	anything
	Calls to:	none
	Algorithm:	read the value of the environment variable DEBUG
	Notes:		usually called from main routine
				"result" should generally be available globally
	Problems:	none known
	Debug:		not used
	References:	none
	Language:	C
	Revisions:	02/23/89  Dennis O'Neill  original version
				03/11/89  mark wiederspahn clean up indenting
*/

#include "output.h"

int get_debug_level ()
{
	char *charptr;								/* ptr to value of DEBUG */
	int result;									/* numeric value of DEBUG */

	if ((charptr = (char *) getenv ("DEBUG")) != NULL)
		result = atoi (charptr);
	else
		result = 0;

	if (result != 0)
		fprintf (D_OUT,"Debug output on at level %d.\n", result);
	return (result);
}
