/*===========================================================================*/
/* UTIG DMC        |            make_blk71.c               | Utility         */
/*===========================================================================*/
/*
	Name:		make_blk71.c

	Purpose:	allocate and link a timespan node
	Usage:		struct blk71_list *make_blk71( head, tail )
	Input:		struct	blk71_list	**head
				struct	blk71_list	**tail
	Output:		pointer to created node
	Externals:	
	Warnings:	
	Errors:		
	Fatals:		calloc returns no space
	Called by:	
	Calls to:	error_handler()
	Algorithm:	If the list is empty, then both head and tail will be null.
				(eg *head = NULL). If there are any nodes on the list, the
				*head and *tail point to the ends; a node is linked in
				in either case.
	Notes:		
	Problems:	
	References:	
	Language:	
	Revisions:	03/10/89	mark wiederspahn	written
*/

#include "output.h"

struct blk71_list *make_blk71( head, tail )
struct	blk71_list	**head;
struct	blk71_list	**tail;
{
/*
 * if this is the first node, point both head and tail to new node
 * else add one onto the existing list at the end.
 */
	if( *tail == NULL )
	{
		*head = *tail =
			(struct blk71_list *)calloc( 1, sizeof(struct blk71_list) );
		if( *tail == NULL ) error_handler( FATAL,"[make_blk71] no space" );
	}
	else
	{
		(*tail)->next = 
			(struct blk71_list *)calloc( 1, sizeof(struct blk71_list) );
		if( *tail == NULL ) error_handler( FATAL,"[make_blk71] no space" );
		(*tail) = (*tail)->next;
	}

	return( *tail );
}
