/*===========================================================================*/
/* DMC interim     |        input_time_to_asc.c            |  Utility        */
/*===========================================================================*/
/*
	Name:		input_time_to_asc.c
	Purpose:	convert struct input_time to SEED time string
	Usage:		string = input_time_to_asc( time )
	Input:		struct	input_time	time
	Output:		char *string of form 1988,123,12:34:56:1234~
	Externals:	none
	Warnings:	none
	Errors:		none
	Fatals:		none
	Called by:	any
	Calls to:	none
	Algorithm:	
	Notes:		the string is overwritten during each call.
				use in form of: strcpy( mystring, input_time_to_asc(time) );
	Problems:	
	References:	
	Language:	ansi C
	Revisions:	03/10/89	mark wiederspahn	written
*/

#include "output.h"

char *input_time_to_asc( time )
struct	input_time	time;		/* time to print out */
{

	static char	buf[24];			/* gets re-written each call! */

	sprintf( buf, "%.4d,%.3d,%.2d:%.2d:%.2d.%.4d~",
		time.year,
		time.day,
		time.hour,
		time.minute,
		time.second,
		time.fracsec );

	return( buf );
}
