/*===========================================================================*/
/* DMC interim out |             constants.h                |    header file */
/*===========================================================================*/
/*
	Name:		constants.h
	Purpose:	define constants used throughout program
	Usage:		
	Input:		
	Output:		
	Externals:	
	Warnings:	
	Errors:		
	Fatals:
	Called by:	
	Calls to:	
	Algorithm:	
	Notes:		
	Problems:	
	Debug:
	References:	
	Language:	
	Revisions:	
*/

/* if this header is already included, don't include it again */
#ifndef CONSTANTS_INCLUDED

                  /*=======================================*/
/*================|       Globally-available constants      |================*/
                  /*=======================================*/

#define STATION_STUB "/data2/seed/tmp/HEADERS/S"    /* search here for stns */

#define MESSAGE 0								/* used by error_handler */
#define OK 0
#define INFO 0
#define WARNING 1
#define ERROR 2
#define FATAL 3

#define D_OUT stderr							/* debug msgs go here */

#define D_NONE 0								/* used w/ Debug settings */
#define D_MIN 1
#define D_INT 2
#define D_MED 2
#define D_SOME 2
#define D_MAX 3

#define PATHLENGTH 256							/* max chars in path name */
#define MSGLENGTH 256							/* max chars in message */

                  /*=======================================*/
/*================|                                         |================*/
                  /*=======================================*/

/* True/false definitions */
#ifndef TRUE
#define FALSE 0
#define TRUE !FALSE
#endif

/* NULL pointer */
#ifndef NULL
#define NULL 0
#endif

/* used during debugging to catch malloc errors; comment out for production */

#ifndef SOLARIS
#ifdef POD_DEBUG
#define MALLOC_DEBUG
#define malloc_debug()
#define malloc_verify()     1
#else
#define malloc_verify()     0
#endif
#else
#define malloc_verify()     1
#endif

/* number of open logrec files, used by logrec package */
#ifndef NFILE
#define NFILE 10
#endif

/* number of bytes at the end of a logical record where a new
 * blockette should not start. Instead, the logical record should
 * be blank padded and the blockette put in the next logical record.
 */
#ifndef ENDPAD
#define ENDPAD 20
#endif

/* ascii space character */
#ifndef SPACE
#define SPACE 32
#endif

/* substitute character for SPACE in database file names
 * for example, "SAFI  " maps to "SAFI##".
 */
#ifndef FNAME_EXTN
#define FNAME_EXTN '#'
#endif

/*
 * character which terminates SEED variable length strings
 */
#ifndef STR_TERM
#define STR_TERM '~'
#endif

/*
 * what default SEED version do we write?
 * This is only the DEFAULT version we write.
 */
#ifndef SEED_DEFAULT
#define SEED_DEFAULT "02.0"
#endif
                  /*=======================================*/
/*================|         End of the header file          |================*/
                  /*=======================================*/

/* the following two lines should be the last lines of the header file */
#define CONSTANTS_INCLUDED 1
#endif
