/*===========================================================================*/
/* DMC interim out |            globals.h                  |     header file */
/*===========================================================================*/
/*
	Name:		
	Purpose:	allocates space for globally-available variables
	Usage:		
	Input:		
	Output:		
	Externals:	
	Warnings:	
	Errors:		
	Fatals:
	Called by:	
	Calls to:	
	Algorithm:	
	Notes:		included only in main routine, BEFORE "output.h"
	Problems:	
	Debug:
	References:	
	Language:	
	Revisions:	
*/

/* If this header is already included, don't include it again */
#ifndef GLOBALS_DEFINED

                   /*=====================================*/
/*=================|    Inclusion of other include files   |=================*/
                   /*=====================================*/

#include "constants.h"

                   /*=====================================*/
/*=================|       Globally-available variables    |=================*/
                   /*=====================================*/

	int Precl;		/* physical record length */
	int Lrecl;		/* logical record length */
	int Debug;		/* Debug flag */
	int SEED_Version;	/* what version we write */
	int Write_Data;		/* flag to write data to volume*/
	char    Organization[80+1];		/* name of creator */

	char Header_path[PATHLENGTH+1];		/* name of Headers dir */

/*
 * ends of the singly linked list which drives the output phase
 * and which is constructed during input phase. There is one node
 * for each time chunk in the output volume.
 */
	struct lvol *Lvol_head;
	struct lvol *Lvol_tail;

/*
 * ends of the singly linked list which drives the output phase
 * and which is constructed during input phase. There is one node
 * for each time span in the output volume.
 * them as well.
 */
	struct tspan_list	*Tspan_head;
	struct tspan_list	*Tspan_tail;

/*
 * ends of the single linked list which contains pointers to all headers
 * (vas, t) constructed internally for this logical volume.
 */
	struct logrec_list	*Headers_head;
	struct logrec_list	*Headers_tail;

/*
 * ends of the single linked list which contains pointers to all blockettes
 * 71 and 72 in file B071 for this logical volume.
 */
	struct blk_71	*Blk71_head;
	struct blk_71	*Blk71_tail;
/*
 * head of a circularly linked list which contains pointers to all of the
 * directory names which could contain time series data. The circular list
 * is to allow "cacheing" of names; channels from a given station will
 * probably be found in the same directory most of the time. This list
 * tends to prevent looking in the wrong places (we hope).
 */
	struct	path_list	*Data_path;


                   /*=====================================*/
/*=================|          end of header file           |=================*/
                   /*=====================================*/

/* the following two lines should be the last lines of the header file */
#define GLOBALS_DEFINED 1
#endif
